//+------------------------------------------------------------------+
//|                                                     Arrows_2.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, "
#property link      ""
//----------------------------------------------------------------------------------------------

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Green
#property indicator_color2 Red


extern string TimeFrame        = "current time frame";
extern int    WPR_Period       = 14;
extern bool   ArrowsOnFirstBar = true;

double WPR_1,WPR_0;
double CrossUp[];
double CrossDown[];
datetime barTime=0; // global variable

int    timeFrame;
string indicatorFileName;
bool   returnBars;


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {

//---- indicators
SetIndexStyle(0, DRAW_ARROW, EMPTY);
SetIndexArrow(0, 233);
SetIndexBuffer(0, CrossUp);
SetIndexStyle(1, DRAW_ARROW, EMPTY);
SetIndexArrow(1, 234);
SetIndexBuffer(1, CrossDown);
indicatorFileName = WindowExpertName();
returnBars        = (TimeFrame=="returnBars"); if (returnBars) return(0);
timeFrame         = stringToTimeFrame(TimeFrame);
return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }

//+------------------------------------------------------------------+  
   
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { CrossUp[0] = limit+1; return(0); }
   
            if (timeFrame!=Period())
            {
               int shift = -1; if (ArrowsOnFirstBar) shift=1;
               limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
               for (int i=limit; i>=0; i--)
               {
                   int y = iBarShift(NULL,timeFrame,Time[i]);   
                   int x = iBarShift(NULL,timeFrame,Time[i+shift]);            
                   
               if (x!=y)
               {
                  CrossUp[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",WPR_Period,0,y);
                  CrossDown[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",WPR_Period,1,y);
                   
                }
            }
            return(0);
            }

//----
int isCrossed20,isCrossed80;
WPR_0 =0 ;
WPR_1=0;
  //---- check for history and trading
if( barTime < Time[0] )
  {
    //ONLY get here IF *new bar*
    // we have a new bar opened
    barTime = Time[0]; // keep the new bar open time
    //now we do ALL new bar work...

for(i=0; i<=limit; i++)
{
WPR_0 = iWPR(NULL,0,WPR_Period,i);
WPR_1 = iWPR(NULL,0,WPR_Period,i+1);

  if(WPR_1>-20)
  {
    isCrossed20 = Crossed20 (WPR_0,WPR_1);
    if(isCrossed20==2)CrossDown[i]=High[i]+0.0020;  
  }
  if(WPR_1<-80)
  {
    isCrossed80  = Crossed80 (WPR_0,WPR_1);
    if(isCrossed80==1)CrossUp[i]=Low[i]-0.0020;  
  }     

}
}  
//----
   return(0);
  }

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

int Crossed20 (double value0, double value1)
   {
      int current_arrow=0;
      int last_arrow=0;
      if(value1>-20 && value0<-20)current_arrow = 2; //down arrow
      else current_arrow=0;
      if(current_arrow != last_arrow) //changed 
      {
            last_arrow = current_arrow;
            return (last_arrow);
      }
      else
      {
            return (0);
      }
   
   }   
  
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

int Crossed80 (double value0, double value1)
   {
      int current_arrow=0;
      int last_arrow=0;
      if(value1<-80 && value0>-80)current_arrow = 1; //up arrow
      else current_arrow=0;
      if(current_arrow != last_arrow) //changed 
      {
            last_arrow = current_arrow;
            return (last_arrow);
      }
      else
      {
            return (0);
      }
     
   }   
   
   //------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}
   